#include "vector2.dm"

aabb
	var
		min_x
		min_y
		max_x
		max_y

		width
		height

	New(MinX, MinY, MaxX, MaxY)
		Set(MinX, MinY, MaxX, MaxY)

	proc
		Set(MinX, MinY, MaxX, MaxY)
			min_x = MinX
			min_y = MinY
			max_x = MaxX
			max_y = MaxY
			width = max_x - min_x
			height = max_y - min_y

		ToText()
			return "([min_x], [min_y] -> [max_x], [max_y])"

		IsIntersecting(aabb/Other)
			return !(\
				   max_x < Other.min_x \
				|| min_x > Other.max_x \
				|| max_y < Other.min_y \
				|| min_y > Other.max_y)

		ContainsPoint(vector2/Point)
			return !(\
				   Point.x < min_x \
				|| Point.x > max_x \
				|| Point.y < min_y \
				|| Point.y > max_y)
